# AAT(Another Activity Tracker) Privacy Policy.

For purposes of this Agreement, “Service” refers to the software's services when it's utilized. “You” refers to you, as a user of the software's services.
The developer is committed to maintaining robust privacy protections for its users. This privacy policy is designed to help you understand how data is collected, used, and how secure that information you provide to us is. This policy statement would assist you in making informed decisions when using our Service.
By utilizing this software, you accept all the terms stated in this Privacy Policy statement, and you consent to the collection, storage, use and disclosure of your Personal Information as described in this Privacy Policy. Kindly note that this privacy policy is restricted only to AAT software and the developer is not, and will not be liable to be held in account for the privacy practices of any third-party tools or services that may be contained in the software.

## Permission and Access

For better and enhanced utilization of AAT, the software is designed to request the provision of certain personally identifiable information. And the enablement of some device permissions. These permissions need to be enabled for the software to work properly on the device on which the software's services are intended.

The permissions are;

- Location
- Storage

**With the location permission enabled, the app can;**

- *access approximate location (network-based).*
- *access precise location (GPS and network-based).*

**With the storage permission enabled, the app can;**

- *modify or delete the contents of your SD card.*
- *read the contents of your SD card.* 


AAT has some other capabilities, which are functions the software can remotely effect on its own. They include; 

- **have full network access**: The app is capable of creating network sockets and can use customized network protocols. This capability does not require the software to send data to the internet.

The information that may be collected with these permissions are stored locally on the device and the developer has no access to that information. These permissions can be revoked when they are not needed. This is privy to only devices running Android 6.0 upward.

## Types of Data Collected

### Personal Data
The developer doesn't collect personally identifiable data. 

### Usage Data
The developer doesn't collect usage data.

### Installation Data
The developer distributes this software via F-droid where download counts are not maintained. Therefore, the developer has no knowledge or way to acquire knowledge about a user that has installed or is using this software. 

## Crash reports

The developer is unable to get crash reports automatically when the app crashes. Instead AAT uses [ACRA][1] to let the user send a generated crash report manually. When the app crashes a dialog gets displayed that gives the user a choice to open the e-mail program to edit and then send a mail with a stack trace attached. The stack trace is a text file that can be displayed with any text editor.

AAT is a project under active development and the developer needs to get information when it doesn't work, to make it work. If you encounter any error while using the software, please open an issue on GitHub and it will be fixed. In a case where the app crashes, try to include logcats in your reports, when possible.

[1]: https://www.acra.ch/

## Service Providers

AAT depends on the services of third-party libraries to facilitate its utilization, and to perform service-related services, or, to assist in analyzing how the services of the software are used. These third parties may have access to your Personal Data but are used only to perform some tasks on the developer's behalf. 

## Transfer Of Data

With these third-party libraries contained in the software, your information, including personal data, may be transferred to computers located outside of your state, province, country or other governmental jurisdiction where the data protection laws may differ than those from your jurisdiction. Your consent to this Privacy Policy followed by your submission of such information represents your agreement to that transfer.

## Links To Other Sites

AAT contains links to other services that are not directly operated by the developer. If you click on a third party library webpage or license URL, you will be directed to that third party's site. The developer has no control over and assumes no responsibility for the content, privacy policies or practices of any third-party sites or services.


## Security Of Data

There are no security risks that may likely occur while using AAT. However, with the inclusion of third-party libraries, the developer cannot guarantee your utmost security. Aside from that, it is also good to note that, no method of transmission over the Internet or method of electronic storage is 100% secure. The developer of AAT assumes no responsibility for data integrity issues caused by using this application.

## Changes To This Privacy Policy

This privacy policy statement is not final and is subject to changes at later times. This is done to accommodate changes in the software's architecture due to further developments and that these changes may not align with several statements and policies stated in the document. With that stated, you are advised to check this policy statement occasionally for any changes that may have occurred. Changes to this policy become effective as soon as they are made. Also occasionally check policies of third-party software that is linked with AAT.

## Disclaimer   

The developer has no commercial interest in this app and doesn't collect any user data. There is no plan to collect data in the future. And this app would never be used to collect data. The only data the developer has access to are log files from a personal [web server](https://bailu.ch). This server is used to provide satellite-based altitude information (dem3 tiles). These files are downloaded once for a specific region. However, the software has an external dependency on third-party libraries that might collect some information when you utilize AAT. These libraries are not directly controlled by the developer, neither does the developer have oversight of the operations of those libraries. Hence, the developer assumes no responsibility for any losses and/or damages of data that are in connection with the use of this software. 

## Contact 

AAT would certainly improve with contributions from the open source community. Feel free to make contributions and suggestions to this project either by opening an issue or implementing opening pull requests of those suggestions and improvements. For further inquiry regarding this privacy policy or any other issue relating to the development or within the circumference of AAT software, please contact the developer either by opening an [issue](https://github.com/bailuk/AAT/issues/new) on the app's official repository [here](https://github.com/bailuk/AAT) on Github. You can also check out the [developer's profile](https://github.com/bailuk) for more information.



